       IDENTIFICATION DIVISION.
      *********************************************************
      *********************************************************
       PROGRAM-ID.   FTPLOGON.
       ENVIRONMENT   DIVISION.
       CONFIGURATION SECTION.
       INPUT-OUTPUT  SECTION.
       FILE-CONTROL.
           SELECT FILEOUT    ASSIGN      TO DATABASE-FTPOPER
                  FILE STATUS            IS STA-FILEOUT.
      *********************************************************
       DATA DIVISION.
       FILE SECTION.

       FD  FILEOUT              LABEL RECORD IS STANDARD.
       01  RIGAOUT PIC X(254).

      *-------------------------------------------------------
       WORKING-STORAGE SECTION.

       77  STA-FILEOUT       PIC XX VALUE "ZZ".
       01  I   PIC S9(4).

       01 INT-USER PIC X(10).

       01 LIBR          PIC X(21).
          88 VALIDA VALUE "/QSYS.LIB/FTPDATA.LIB"
                          "/QSYS.LIB/SAPDATA.LIB".


       01 INT-PASSWD PIC X(10).

       01 USYSDATL.        COPY USYSDATL.
       01 LOG-RIGA.
           05 LOG-DATA     PIC X(10).
           05 LOG-ORA      PIC X(8).
           05 LOG-TCPIP    PIC X(15).
           05 LOG-USER     PIC X(10).
           05 LOG-EXEC     PIC X.
           05 LOG-OPER     PIC X(10).
           05 LOG-OPERAZ   PIC X(200).

      *******************************
       LINKAGE SECTION.

       01 GRUPPO       PIC X(10).
       01 APP-IDENT    PIC 9(8) COMP-4.
       01 OPR-IDENT    PIC 9(8) COMP-4.
       01 UTENTE       PIC X(10).
       01 IPADDR       PIC X(15).
       01 IPADDR-LEN   PIC 9(8) COMP-4.
       01 OPERAZ       PIC X(9999).
       01 OPERAZ-LEN   PIC 9(8) COMP-4.
       01 RETRN-CODE   PIC 9(8) COMP-4.

      ********************************************************
       PROCEDURE DIVISION USING GRUPPO
                                APP-IDENT OPR-IDENT UTENTE
                                IPADDR IPADDR-LEN
                                OPERAZ OPERAZ-LEN
                                RETRN-CODE.
       PROC-DIV.

           OPEN EXTEND FILEOUT.
           IF STA-FILEOUT NOT = "00"
              DISPLAY "ERRORE FILE " STA-FILEOUT
           END-IF.

      *-- THIS A CALL TO OUR "Y2K SAFE" ACCEPT FROM DATE
           CALL "USYSDATE" USING USYSDATL.
           MOVE SYS-DATE1  TO LOG-DATA
           MOVE SYS-TIME1  TO LOG-ORA

           MOVE  UTENTE  TO LOG-USER
           MOVE  IPADDR (1 : IPADDR-LEN) TO LOG-TCPIP

      *--- THIS IS BECAUSE THIS EXIT PROGRAM IS CALLED ALSO FOR
      *--- OTHER APPLICATIONS
           IF APP-IDENT NOT = 1 AND NOT = 0
              MOVE 1 TO RETRN-CODE
              GO TO FINE
           END-IF.

           MOVE 0     TO RETRN-CODE

      *-- POSSIBLE VALUE FOR  RETRN-CODE
      *
      *   -1 : REJECT  OPER. FOR THE WHOLE SESSION
      *    0 : REJECT  OPER.
      *    1 : ACCEPT  OPER.
      *    2 : ACCEPT  OPER. FOR THE WHOLE SESSION
      *-- "FOR THE WHOLE SESSION" MEANS THAT ROUTINE WILL NEVER
      *-- BE CALLED AGAIN FOR THAT SESSION.

           MOVE OPR-IDENT  TO LOG-OPER

           EVALUATE OPR-IDENT
      *-- INITIALIZE
             WHEN 0  MOVE 2            TO RETRN-CODE
                     MOVE "CONNECT"    TO LOG-OPER

      *-- CREATE LIBRERY/DIRECTORY
             WHEN 1  MOVE 0 TO RETRN-CODE
                     MOVE "CRTLIB "    TO LOG-OPER

      *-- DELETE LIBRERY/DIRECTORY
             WHEN 2  MOVE 0 TO RETRN-CODE
                     MOVE "DLTLIB "    TO LOG-OPER

      *-- CHANGE LIBRERIA/DIRECTORY
             WHEN 3  MOVE 0 TO RETRN-CODE
                     MOVE "CURLIB "    TO LOG-OPER

      *-- LIST FILE
             WHEN 4  MOVE 2  TO RETRN-CODE
                     MOVE "LIST   "    TO LOG-OPER

      *-- DELETE  FILE
             WHEN 5  MOVE 0 TO RETRN-CODE
                     MOVE "DLTF   "    TO LOG-OPER

      *-- DOWNLOAD FILE
             WHEN 6  MOVE 1  TO RETRN-CODE
                     MOVE "DOWNLOAD"   TO LOG-OPER

      *-- UPLOAD FILE
             WHEN 7  MOVE 1  TO RETRN-CODE
                     MOVE "UPLOAD "    TO LOG-OPER

      *-- RENAME FILE
             WHEN 8  MOVE 1  TO RETRN-CODE
                     MOVE "RENAME "    TO LOG-OPER

      *-- EXEC SYSTEM COMMAND !!!!!!!!!!!!!!!!!!!!!!!!!!!
             WHEN 9  MOVE 0 TO RETRN-CODE
                     MOVE "EXEC!  "    TO LOG-OPER

           END-EVALUATE.

           IF OPR-IDENT NOT = 0
              MOVE OPERAZ (1 : 21) TO LIBR
              IF NOT VALIDA
                 MOVE 0 TO RETRN-CODE
              END-IF
           END-IF.

       LOGGA.
           MOVE OPERAZ (1 : OPERAZ-LEN) TO LOG-OPERAZ
           EVALUATE RETRN-CODE
              WHEN -1 MOVE "N" TO LOG-EXEC
              WHEN  0 MOVE "N" TO LOG-EXEC
              WHEN  1 MOVE "S" TO LOG-EXEC
              WHEN  2 MOVE "S" TO LOG-EXEC
           END-EVALUATE.

           WRITE RIGAOUT FROM LOG-RIGA.
       FINE.
           CLOSE FILEOUT.
           Exit program.
      *-------------------------------------------------------
